# If the example path is not set, default to current directory
if(!defined $example)
{
  $example = "./";
}


$targetNumber = 8; 
$nFits=10

$landmarks = sprintf("mesh_%02d", 1);
$target = sprintf("mesh_%02d", $targetNumber);

$HOST 		= 1;
$SLAVE 		= 2;
fem def para;r;fitting;example
fem def region;r;regions;example


################ SLAVE MESH ################ 
fem def coord;r;slaveCoord;example reg $SLAVE;
fem define base;r;bases2;example reg $HOST,$SLAVE

$name = "mesh_1"
fem define node;r;mesh_1;example reg $SLAVE
fem define elem;r;slave;example reg $SLAVE
fem export node;slave as slave offset 1000 reg $SLAVE
fem export elem;slave as slave offset_elem 1000 reg $SLAVE

################ HOST MESH #################
fem def coor;r;hostCoord;example reg $HOST;
fem def node;r;host_1;example reg $HOST;
fem def elem;r;host;example reg $HOST;
fem export node;host as host offset 1500 reg $HOST;
fem export elem;host as host offset_elem 1500 reg $HOST;

######### HOST MESH TRANSFORMATION #########
#fem def xi;c nodes contain of $SLAVE in $HOST loose_tolerance by 10
fem def xi;c nodes contain of $SLAVE in $HOST
fem def xi;w;slave nodes contain of $SLAVE in $HOST

fem def data;r;$landmarks;example   #reads in global coords of landmark points
fem export data;landmark as landmark offset 16000 reg $HOST
fem def xi;c contain reg $HOST;   #calculates xi posns of landmark points in host
#fem def xi;c close reg $HOST;   #calculates xi posns of landmark points in host
fem def xi;w;landmark reg $HOST;

fem def data;r;$target;example         #reads in global coords of target points
fem def xi;r;landmark;example reg $HOST;
fem export data;target as target error offset 17500 reg $HOST

fem list data error reg 1;     #outputs initial error

fem update field from geometry reg $HOST;
fem def fit;r;host;example geom reg $HOST

# Fitting the motion of the hostmesh to the data-points
# ignoring error component normal to image-plane
fem fit in_plane reg $HOST;

fem def xi;r;slave;example nodes contain of $SLAVE in $HOST;
fem update mesh position fit of $SLAVE in $HOST;
$name = "fittedMesh_$targetNumber";
fem def node;w;$name reg $SLAVE

fem update node fit reg $HOST;
fem def data;r;$landmarks;example
fem define data;c from_xi
fem define data;w;newLandmark

system("perl markerError.pl 8");


for($n=2;$n<=$nFits;$n++)
{

  print "\n\n\************************************\n"
  print "\n\n\Fit number $n\n"
  print "\n\n\************************************\n"

  fem def data;r;newLandmark;example
  #fem def xi;c contain reg $HOST;
  fem def xi;c close reg $HOST;
  fem def xi;w;landmark2 reg $HOST;
  fem def data;r;$target;example
  fem def xi;r;landmark2 reg $HOST;
  
  fem update field from geometry reg $HOST;
  fem def fit;r;host;example geom reg $HOST
  
  # Fitting the motion of the hostmesh to the data-points
  # ignoring error component normal to image-plane
  fem fit in_plane reg $HOST;
  
  fem def xi;r;slave;example nodes contain of $SLAVE in $HOST;
  fem update mesh position fit of $SLAVE in $HOST;
  $name = "fittedMesh_$targetNumber";
  fem def node;w;$name reg $SLAVE
  #fem def elem;w;$name reg $SLAVE

  fem update node fit reg $HOST;
  fem export data;data_cust as data_cust error offset 18000 reg $HOST
  fem def data;r;$landmarks
  $name = "newLandmark";
  fem define data;c from_xi
  fem define data;w;$name

  #system("perl markerError.pl $targetNumber");
}


############# SLAVE MESH UPDATE ############

fem def xi;r;slave;example nodes contain of $SLAVE in $HOST;
fem update mesh position fit of $SLAVE in $HOST;

fem export node;transformed_slave as transformed_slavex offset 00000 reg $SLAVE;
fem export elem;transformed_slave as transformed_slavex offset_elem 00000 reg $SLAVE;

$name = "preparedMesh_$targetNumber";
fem def node;w;$name reg $SLAVE
#fem def elem;w;$name reg $SLAVE

############# HOST MESH UPDATE #############

fem update node fit reg $HOST;
fem export node;deformed_host as deformed_host offset 2000 reg $HOST;
fem export elem;deformed_host as deformed_host offset_elem 2000 reg $HOST;

fem def data;r;$landmarks;example
$name = "newLandmark";
fem define data;c from_xi
fem define data;w;$name
fem export data;$name as $name error offset 0

#system("perl markerError.pl $targetNumber");

