#Example_321 A Simple boundary element example

fem
fem define node;r;simplebem;example  #Read in the nodes for a simple BEM problem
fem define window;c              #Calculate the window size
fem draw nodes                   #Draw the nodes
fem define base;p                #Define a boundary element basis. Define
#                                !  1 Boundary element Lagrange/Hermite
#                                !  tensor product basis with 1 xi direction
#                                !  and quadratic Lagrange interpolation.
#                                !  Default all other options.
fem list base                    #List the basis function
fem list base family 1           #List the all the basis functions associated
#                                !  with the various quadrature schemes
#                                !  required for BEM.
fem define elem;p                #Define 4 quadratic (3 local nodes) elements.
#                                !  With boundary elements we need to take
#                                !  care with which way our Xi direction
#                                !  goes in order to correctly define the
#                                !  OUTWARD normal for the mesh. In cmiss
#                                !  the convention is that as we move along
#                                !  in increasing Xi the interior of the
#                                !  mesh domain is kept to the right. Hence
#                                !  for this case, where the solution domain
#                                !  is the interior of a circle, the direction
#                                !  of increasing Xi must be clockwise. The
#                                !  local nodes for each element are hence:
#                                !  Element 1 - 1,8,7; Element 2 - 7,6,5;
#                                !  Element 3 - 5,4,3; and Element 4 - 3,2,1.
fem draw lines                   #Draw the lines
fem draw gauss                   #Draw the Gauss points
fem define equation;p            #Define a Static Analysis (Standard) 
#                                !  Laplace's Equation using Direct Boundary
#                                !  elements. Default all other options
fem define materials;p           #Define (no) materials.
fem define initial;p             #Define the boundary conditions. For
#                                !  boundary elements you have two unknowns
#                                !  each node - the variable (e.g temperature)
#                                !  and its normal derivative (e.g. heat flux)
#                                !  and you must specify exactly one of these
#                                !  at each node. Specify temperature 
#                                !  essential boundary conditions of:
#                                !  Node 1 - 10; Nodes 2,8 - 5; Nodes 3,7 - 0
#                                !  and flux boundary conditions of:
#                                !  Nodes 4,5,6 - 0.
fem define solve;p               #Define the solve options.
#                                !  Default for all questions.
fem solve                        #Solve the boundary value problem.
fem list node solution           #List the nodal solutions (temperatures).
fem list node flux               #List the nodal fluxes.
