#Example_333 Heating of a cast iron furnace wall    
                                                                      
fem                             #Set the FEM environment 
fem define nodes;r;furnace;example  #Read in the nodes to define a furnace wall
fem define window;c             #Calculate the window size
fem define bases;r;;example         #Defines a bilinear basis function
fem define elements;r;;example      #Read in the elements to define a furnace wall
fem draw line                   #Draw the lines
fem define equation;p           #Define a TIME INTEGRATION analysis of 
#                               !  the ADVECTION-DIFFUSION equation
#                               !  using GALERKIN FINITE ELEMENTS with 
#                               !  LINEAR ANALYSIS. Default all other options.
#                               !  Note that the advection-diffusion equation 
#                               !  in CMISS is of the form
#                               !  s. del T/del t + u. grad T = 
#                               !  D_i. del^2 T/del x_i^2 + a + b.T
#                               !  where a is the constant source term, b
#                               !  is the linear source term, s the storage
#                               !  coefficient, D_i the diffusion coefficients
#                               !  (in each direction) and u the velocity 
#                               !  vector (mass flow in each direction).
#                               !  The heat equation is, on the other hand, of
#                               !  the form 1/alpha. del T/del t = 
#                               !  del^2 T/del x_i^2 where alpha is the thermal
#                               !  diffusivity and is equal to k/(rho.C) where
#                               !  k is the thermal conductivity, rho the 
#                               !  density and C the specific heat.
fem define material;p           #Define material properties. Comparing the
#                               !  advection-diffusion equation with the heat
#                               !  equation (above) we can make the 
#                               !  advection-diffusion equation govern the
#                               !  heat flow in the cast iron wall by setting
#                               !  both the constant and linear source terms
#                               !  to zero, the storage coefficient to be
#                               !  1/alpha (= 6.585 s/cm^2 because 
#                               !  1/alpha=65850 s/m^2 for grey cast iron, 
#                               !  however the wall is only 1 cm thick),
#                               !  the diffusion coefficients to be 1,
#                               !  and the mass flows zero. (Default the rest).
fem define initial;p            #Define the initial conditions. The initial
#                               !  solution is zero. Set Nodes 1 and 7 to 
#                               !  zero degrees C and nodes 6 and 12 to 1000
#                               !  degrees C.     
fem define solve;p              #Defines solver options. Default all options
#                               !  except set the final time to 3 seconds and
#                               !  the time increment to 0.1 seconds.
fem solve                       #Solve the time integration problem
fem display history             #Display the nodal time history.
fem draw field animate          #Show the temperature field over time. You
#                               !  want to ensure that the spectrum in the
#                               !  GX window #1 is set to Light to Dark.
#                               !  Note this may take a little while.
