#!/bin/tcsh
#
# Shell file to extract errors from CMISS output files (appends to output file).
#
# Usage:
#   get_data.sh data_file output_file_basename
#
# Example:
#   get_data.sh sphere_1_bem_100_1_04_04_vary_x_x sphere_1_bem_100_1_04_04_0_x_x
#
# Created:
#   Glen Harris, 15 October 1996
#
# Updates:
#
set temp_file=/tmp/temp.dat
#Get parameter information from the filename
${CMISS_ROOT}/examples/3/35/split_name $2 > ${temp_file}
#Get the error for the integral squared potential and flux in the inner region (*100 to make percentage)
${CMISS_ROOT}/examples/3/35/get_rms.sh Relative 1 $2_inner.out >> ${temp_file}
${CMISS_ROOT}/examples/3/35/get_rms.sh Relative 2 $2_inner.out >> ${temp_file}
#Get the error for the integral squared potential in the outer region (*100 to make percentage)
${CMISS_ROOT}/examples/3/35/get_rms.sh Relative 1 $2_outer.out >> ${temp_file}
#Take the temp file, and put the contents (all on one line) in the data file
echo "`cat ${temp_file}`" >> $1.dat
#Tidy up
rm -f ${temp_file}
