#Example_531  Inflation and 10% axial extension of a cylinder using r interpol.n                                                    
                                                                       
fem                                                                
fem define coordinates;r;cylind;example #Define 3 GLOBAL CYLINDRICAL POLAR 
#                               !  coordinates for an UNSYMMETRIC
#                               !  GEOMETRY, RADIAL INTERPOLATION in r.
#                               !  Written to file CYLIND.ipcoor.
fem define node;r;;example          #4 NODES, 3 COORDINATES, NO VERSION 
#                               !  PROMPTING, 0 DERIVATIVES for all 
#                               !  coordinates. Nodal coordinates (Xj)
#                               !  are (R,theta,Z): 1=(2,0,0);2=(2,0,1);
#                               !  3=(3,0,0); 4=(3,0,1).
fem define base;r;;example          #Define 3 BASIS FUNCTIONS. Choose 
#                               !  LAGRANGE/HERMITE for basis function 1
#             !  with 3 Xi COORDINATES, a LINEAR LAGRANGE interpolant 
#             !  and 1 GAUSS POINT each in Xi(1) (circumferential) and 
#             !  Xi(2) (axial) directions but 3 in Xi(3) (radial).
#             !  For basis function 2 (hydrostatic pressure), choose an
#             !  AUXILIARY BASIS with 5 AUXILIARY ELEMENT PARAMETERS,
#             !  PRESSURE BASIS with 3 Xi coordinates and the same
#             !  number of Gauss points as basis function 1. For all 5
#             !  parameters choose POLYNOMIAL DEGREE of 0 (ie constant)
#             !  in Xi1 and Xi2 directions. For parameters 1;2;3;4;5 
#             !  choose POLYNOMIAL DEGREE 0;1;2;-1;-2 respectively
#             !  (0;1;2 denote a quadratic variation in the hydrostatic
#             !  pressure in Xi3 whilst -1;-2 denotes parameters for
#             !  Xi3=0;Xi3=1 face pressure bc respectively.)  Basis
#             !  function 3 describes surfaces and thus has 2 Xi
#             !  COORDINATES with LINEAR LAGRANGE interpolant, and 3
#             !  Gauss points in Xi(1) and Xi(2) directions.
fem define element;r;;example       #1 ELEMENT with 3 Xj COORDINATES. BASIS
#                               !  FUNCTION 1 describes each coordinate.
#                               !  GLOBAL NODE # is 1,1,2,2,3,3,4,4.
fem define window;r;;example        #Define window dimensions in X,Y,Z 
#                               !  directions as (min,max): (-4,4),
#                               !  (-4,4), (-1,2).
fem draw lines                  #Make line segments visible on window.
fem define equation;r;;example      #Defines equation the same as in the  
#                               !  uniaxial cube extension problem.
fem define material;r;;example      #Defines a Mooney-Rivlin material as in 
#                               !  the uniaxial cube extension problem.
fem define initial;r;;example       #BOUNDARY PRESSURE INCREMENTS will be 
#                               !  entered and HYDROSTATIC PRESSURE will
#             !  be matched across elements with adjacent Xi3 faces 
#             !  (none in this example). INITIAL DISPLACEMENTS are ALL
#             !  ZERO. For equation 2 (theta-direction) fix node 1; for
#             !  equation 3 (Z-direction), fix nodes 1,3 and apply 0.1
#             !  displacement to nodes 2,4. Pressure bcs are applied
#             !  via DEPENDENT VARIABLE/EQUATION 4. For ELEMENT 1 DO NOT
#             !  prescribe bcs for parameters 1,2,3; to apply a pressure
#             !  of magnitude 1 on Xi3=0 face(inside cylinder) prescribe
#             !  an INCREMENT of 1.0 to AUXILIARY VARIABLE 4.  To apply
#             !  a pressure of magnitude 0 on Xi(3)=1 face (outside 
#             !  cylinder) prescribe an INCREMENT of 0.0 to AUXILIARY 
#             !  VARIABLE 5.
fem define solve;r;;example         #Defines solution information.
fem solve step 1                #Solve the problem, (should converge
#                               !  in about 6 iterations).
fem draw lines def dotted       #Draw deformed mesh.
fem list strain at 1 ref        #List strain information wrt reference
#                               !  coordinates at 1st gauss point.
fem list stress at 1 ref        #List stress information wrt reference
#                               !  coordinates at 1st gauss point.
fem list elem tot
fem list elem deformed total
              #Note that volume is not conserved with quadratic transmural
              #  hydrostatic pressure and r interpolation (I3 not equal
              #  to 1).  The radial stress at the first Gauss point is
              #  near the inner radius where the stress should be close 
              #  to the applied pressure (-1) but is quite different.
              #  At the third Gauss point (display this point by 
              #  repeating the last command and replace the "1" with a
              #  "3"), near the outer radius, the radial stress should
              #  be near zero but is again quite different from what is
              #  expected.  Contrast these results with the next
              #  sample problem.
