#
#inflation
#
set out;steps_inflate on

$NAME1 = "heart"
$ITERS = 20
$TOL = 0.001
$NOFILES = 10
$INCREMENT = 1/$NOFILES

#
#increase cavity pressures incrementally 
#to simulate diastole.
#

for ($PRESS = 0; $PRESS <= $NOFILES; $PRESS++)  
{

  if( $PRESS < 1 )
  {
    #$FILENAME = "${NAME1}0$PRESS$NAME2"
    $FILENAME = "${NAME1}0$PRESS"
    $INCREM = 0.0
  } 
  elsif( $PRESS < 10 )
  {
    $FILENAME = "${NAME1}0$PRESS"
    $INCREM = $INCREMENT
  } 
  else
  {
    $FILENAME = "${NAME1}$PRESS"
    $INCREM = $INCREMENT
  }

  print "\n\n\nCalculating file #: $PRESS\n"

  #fem solve increment $INCREM iter $ITERS error $TOL
  fem solve increment $INCREM iter $ITERS
  fem export nodes;$FILENAME field as heart
  fem export elements;$FILENAME field as heart
  #fem define initial;w;$FILENAME
  
  system "sed 's/ields=2/ields=3/g' $FILENAME.exnode > $FILENAME.exnode_tmp"
  system "sed 's/1) def/2) def/g' $FILENAME.exnode_tmp > $FILENAME.exnode"
  system "rm $FILENAME.exnode_tmp"
}

set out off


