# Example 5522 - Dynamic active contraction of a high-order prolate LV using HMT

# Solves the ventricular mechanics model coupled to a cell HMT model,
# previously set up using the cm command file:
# mech_hmt_setup.com

# Martyn Nash and David Nickerson June 2000


# Output file names

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable SOLNSDIR solutions/
$SOLNSDIR = "solutions/"


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable OUTFILE $SOLNSDIR//mech_hmt
$OUTFILE = "${SOLNSDIR}mech_hmt"


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable MATRIXFILE $SOLNSDIR//matrices_yq_yqs
$MATRIXFILE = "${SOLNSDIR}matrices_yq_yqs"


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable MECHSOLFILE $SOLNSDIR//mechsol
$MECHSOLFILE = "${SOLNSDIR}mechsol"


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable HISTFILE $SOLNSDIR//hmt
$HISTFILE = "${SOLNSDIR}hmt"


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable SIGFILEBASE $SOLNSDIR//hmt_
$SIGFILEBASE = "${SOLNSDIR}hmt_"


# Set the reference tension (in kPa) and tolerance for the 
# maximum and minimum absolute differences (percentages)
# (note this is specified at a percentage of T_REF)

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable T_REF 100.0
$T_REF = 100.0


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable TDIFF_TOLMIN 1
$TDIFF_TOLMIN = 1


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable TDIFF_TOLMAX 10
$TDIFF_TOLMAX = 10


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable PCT_TDIFF 0
$PCT_TDIFF = 0


# Other variables

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable T_MAXABSDIFF 0.0
$T_MAXABSDIFF = 0.0


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable SOLVEMECH $FALSE
$SOLVEMECH = $FALSE


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable MAX_ITER_MECH 10
$MAX_ITER_MECH = 10


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable ITER_MECH2 0
$ITER_MECH2 = 0


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable MAX_ITER_MECH2 3
$MAX_ITER_MECH2 = 3


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable ITER_CELL 0
$ITER_CELL = 0


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable MAX_ITER_CELL 10
$MAX_ITER_CELL = 10


# Signals to export
# Vm = 1, Cab = 2, z = 3, L = 4, Tension = 5, IsoTension = 6, Cai = 7

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable SIGNALS 1..7
$SIGNALS = "1..7"


# File format

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable FORMAT binary
$FORMAT = "binary"


# Tension index for grid (YQS) and Gauss (YG) variables
fem inquire cell_variable Tension return_variables T_GRIDARRAY,T_GRIDIDX

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable T_GAUSSARRAY "YG"
$T_GAUSSARRAY = "YG"


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable T_GAUSSIDX 1
$T_GAUSSIDX = 1


# Fibre extension ratio index for grid (YQS) and mechanics variables
fem inquire cell_variable ExtensionRatio return_variables L_GRIDARRAY,L_GRIDIDX

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable L_MECHIDX 1
$L_MECHIDX = 1


# Time and stepping variables

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable TIME 0.0
$TIME = 0.0


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable TEND 500.0
$TEND = 500.0


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable TSTEP 1.0
$TSTEP = 1.0


# Open the HMT cell history file
fem open history;$HISTFILE write unit 21 variables yqs niqslist $SIGNALS $FORMAT class $CELL

set output;$OUTFILE on

# Compute and store fibre extension ratio for HMT grid problem
fem update grid extension_ratio component $L_MECHIDX $L_GRIDARRAY $L_GRIDIDX region $WALL class $MECH

# Set up checkpoint matrix
# Write the YQ (grid contiuum vars) and YQS (cell vars) matrices

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: assign variable LASTMECHTIME $TIME
$LASTMECHTIME = $TIME

here 22 25

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: fem write matrix;$MATRIXFILE//_//format($LASTMECHTIME,F8.4) matrices YQ,YQS $FORMAT
fem write matrix;${MATRIXFILE}_sprintf("%8.4f",$LASTMECHTIME)) matrices YQ,YQS $FORMAT


# Echo commands for command file debugging
set echo

########################################################################
# MAIN SOLUTION LOOP
########################################################################
while(($TIME < $TEND) && ($ITER_MECH2 < $MAX_ITER_MECH2))


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:   TIME = $TIME + $TSTEP
{
$TIME = $TIME + $TSTEP


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:   output " "
print " "


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:   output " *******************************************"
print " *******************************************"

here 1 19

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:   output " TIME = "//format($TIME,F16.4)//" msec"
print " TIME = sprintf("%16.4f",${TIME))} msec"


  fem evaluate time variable cai time $TIME

# Solve the HMT cell model for the current time
  fem solve restart to $TIME class $CELL

# Get maximum absolute tension difference over all Gauss pts
  fem compare gaussvars gridvars $T_GRIDARRAY $T_GRIDIDX $T_GAUSSARRAY $T_GAUSSIDX region $WALL return maxabsdiff to_variable T_MAXABSDIFF 


########################################################################
# Determine if the mechanics problem needs resolving/updating


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:   PCT_TDIFF = 100.0 * $T_MAXABSDIFF / $T_REF
$PCT_TDIFF = 100.0 * $T_MAXABSDIFF / $T_REF


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:   output " "
print " "

here 1 23

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:   output " Maximum tension difference: "//format($PCT_TDIFF,F8.2)//" %"
print " Maximum tension difference: sprintf("%8.2f",${PCT_TDIFF))} %"


if($PCT_TDIFF < $TDIFF_TOLMIN)
#   Tension has not changed appreciably so don't solve mechanics

#   Write the grid variables to the history file

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     fem write history unit 21 time $TIME variables yqs $FORMAT class $CELL
{
    fem write history unit 21 time $TIME variables yqs $FORMAT class $CELL


#    TSTEP = $TSTEP * 2.0

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     SOLVEMECH=$FALSE
$SOLVEMECH=$FALSE


########################################################################

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:   ELSEIF($PCT_TDIFF > $TDIFF_TOLMAX)
} elsif($PCT_TDIFF > $TDIFF_TOLMAX)

#   Tension has changed too much so restart from previous cell checkpoint
#   time step, but using a smaller time step (don't solve mechanics)


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     output " >>>INFO: Tension has changed by too much. Re-starting from previous checkpoint."
{
print " >>>INFO: Tension has changed by too much. Re-starting from previous checkpoint."


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     output " "
print " "


#   Restart cell problem from last checkpoint
#   Read the YQ (grid contiuum vars) and YQS (cell vars) matrices
here 22 25

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     fem read matrix;$MATRIXFILE//_//format($LASTMECHTIME,F8.4) matrices YQ,YQS $FORMAT 
fem read matrix;${MATRIXFILE}_sprintf("%8.4f",$LASTMECHTIME)) matrices YQ,YQS $FORMAT



# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     TIME = $TIME - $TSTEP
$TIME = "$TIME - $TSTEP"

    fem solve from $LASTMECHTIME to $TIME class $CELL


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     TSTEP = $TSTEP / 2.0
$TSTEP = $TSTEP / 2.0


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     output " "
print " "

here 1 20

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     output " Time step halved: TSTEP = "//format($TSTEP,F16.8)//" msec"
print " Time step halved: TSTEP = sprintf("%16.8f",${TSTEP))} msec"


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     output " "
print " "


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     output " *******************************************"
print " *******************************************"

here 1 19

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     output " TIME = "//format($TIME,F16.4)//" msec"
print " TIME = sprintf("%16.4f",${TIME))} msec"



# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     output " "
print " "

    fem evaluate time variable cai time $TIME


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     ITER_CELL = $ITER_CELL + 1
$ITER_CELL = $ITER_CELL + 1



# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     IF($ITER_CELL == $MAX_ITER_CELL)
$if($ITER_CELL == $MAX_ITER_CELL)


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:       SOLVEMECH=$TRUE
{
$SOLVEMECH=$TRUE


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     ELSE
} else


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:       SOLVEMECH=$FALSE
{
$SOLVEMECH=$FALSE


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     ENDIF
}


########################################################################

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:   ELSE
} else

#   Tension has changed by a suitable amount to now resolve mechanics


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     SOLVEMECH=$TRUE
{
$SOLVEMECH=$TRUE



# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:   ENDIF
}



########################################################################
if($SOLVEMECH)


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     IF($LASTMECHTIME == $TIME)
{
$if($LASTMECHTIME == $TIME)


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:       ITER_MECH2 = $ITER_MECH2 + 1
{
$ITER_MECH2 = $ITER_MECH2 + 1


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     ELSE
} else


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:       ITER_MECH2 = 0
{
$ITER_MECH2 = 0


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     ENDIF
}


#   Checkpoint the cell problem

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     LASTMECHTIME=$TIME
$LASTMECHTIME=$TIME


#   Write the YQ (grid contiuum vars) and YQS (cell vars) matrices
here 22 25

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     fem write matrix;$MATRIXFILE//_//format($LASTMECHTIME,F8.4) matrices YQ,YQS $FORMAT 
fem write matrix;${MATRIXFILE}_sprintf("%8.4f",$LASTMECHTIME)) matrices YQ,YQS $FORMAT


#   Interpolate active tension from grid point variables to Gauss pts
    fem update gauss gridvars $T_GRIDARRAY $T_GRIDIDX $T_GAUSSARRAY $T_GAUSSIDX region $WALL

#   Solve the mechanics problem using the updated active tension
    fem solve class $MECH increment 0.0 iterate $MAX_ITER_MECH error $MECH_ERRTOL

#   Save mechanics solution
here 26 17

# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     fem define initial;w;$MECHSOLFILE//_//format($TIME,F8.4) region $WALL class $MECH
fem define initial;w;${MECHSOLFILE}_sprintf("%8.4f",$TIME)) region $WALL class $MECH


#   Compute and store fibre extension ratio for HMT grid problem
    fem update grid extension_ratio component $L_MECHIDX $L_GRIDARRAY $L_GRIDIDX region $WALL class $MECH


# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:     ITER_CELL = 0
$ITER_CELL = 0



# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command:   ENDIF
}



# Command updated by fixcom.sh on Wed Aug 23 18:20:26 NZT 2000
# Old command: ENDWHILE
}


set output off

# Close the HMT cell history file
fem close history unit 21 $FORMAT class $CELL


## Write out signal files for the state variables.
#DO SIGNAL=$SIGNALS
## Only write out the one signal
#  fem evaluate electrode;$SIGFILEBASE//$SIGNAL history $HISTFILE from grid yqs iy $SIGNAL $FORMAT class $CELL
#  fem define export;r;hmt
#  fem export signal;$SIGFILEBASE//$SIGNAL electrode signal $SIGFILEBASE//$SIGNAL
#ENDDO
