{

if (!(-e "lv1.ipnode") | !(-e "lv4.ipnode") | !(-e "lv5.ipnode") | !(-e "lv7.ipnode"))
{
  die "Input-file(s) doesn't exist";
}



$nFiles = 4;
CORE::open(LV1_FID, "lv1.ipnode") || die "Couldn't open lv1.ipnode"; 
CORE::open(LV4_FID, "lv4.ipnode") || die "Couldn't open lv4.ipnode"; 
CORE::open(LV5_FID, "lv5.ipnode") || die "Couldn't open lv5.ipnode"; 
CORE::open(LV7_FID, "lv7.ipnode") || die "Couldn't open lv7.ipnode"; 
CORE::open(MEAN_FID, ">meanLV.ipnode") || die "Couldn't open meanLV.ipnode";


$boolFinished = 0;
while (!($boolFinished))
{
  #Read in Heading until Element 1. Calculate mean focus. And write out heading.
  $focus = readFocus();
  #print $focus, "\n";
  print MEAN_FID " CMISS Version 1.21 ipnode File Version 2\n";
  print MEAN_FID " Heading: mean node values of a 30 element LV\n";
  print MEAN_FID "\n";
  print MEAN_FID " Specify the focus position [1.0]:   $focus\n";
  for($n=1; $n<10; $n++)
  {
    $line1 = <LV1_FID>;
    $line4 = <LV4_FID>;
    $line5 = <LV5_FID>;
    $line7 = <LV7_FID>;
    print MEAN_FID $line1;
  }

  #Endo apex node
  $return = readLambda();
  $return = readApexMuandTheta();
  #Endo nodes
  for ($k=2; $k<32; $k++)
  {
    $return = readLambda();
    $return = readMuandTheta();
  } 
   #Epi Apex node
  $return = readLambda();
  $return = readApexMuandTheta();
  #Epi Nodes
  for ($k=33; $k<63; $k++)
  {
    $return = readLambda();
    $return = readMuandTheta();
  } 

  $boolFinished = 1;
}


CORE::close(LV1_FID);
CORE::close(LV4_FID);
CORE::close(LV5_FID);
CORE::close(LV7_FID);
CORE::close(MEAN_FID);


#Funtion readFocus
#This function reads in the focus of the input files and returns the 
#average of the focuses
sub readFocus
{
  my $focus =0;
  my $n;
  my $line1;
  my $line4;
  my $line5;
  my $line7;

  for($n=1; $n<5; $n++)
  {
    $line1 = <LV1_FID>;
    $line4 = <LV4_FID>;
    $line5 = <LV5_FID>;
    $line7 = <LV7_FID>;
  }

  $line1 =~ s/D/e/;
  $line1 =~ m/ Specify the focus position \[.+\]:(.+)/;
  $focus = $focus+$1;

  $line4 =~ s/D/e/;
  $line4 =~ m/ Specify the focus position \[.+\]:(.+)/;
  $focus = $focus+$1;

  $line5 =~ s/D/e/;
  $line5 =~ m/ Specify the focus position \[.+\]:(.+)/;
  $focus = $focus+$1;

  $line7 =~ s/D/e/;
  $line7 =~ m/ Specify the focus position \[.+\]:(.+)/;
  $focus = $focus+$1;

  return ($focus/$nFiles);
}


sub readLambda()
{
  my $x = 0;

  $line1 = <LV1_FID>;
  $line4 = <LV4_FID>;
  $line5 = <LV5_FID>;
  $line7 = <LV7_FID>;
  print MEAN_FID $line1;

  #Coordinate
  $x =0;
  $line1 = <LV1_FID>;
  $line4 = <LV4_FID>;
  $line5 = <LV5_FID>;
  $line7 = <LV7_FID>;
  $line1 =~ m/ The Xj\(1\) coordinate is \[.+\]:(.+)/;
  $x = $x + $1;
  $line4 =~ m/ The Xj\(1\) coordinate is \[.+\]:(.+)/;
  $x = $x + $1;
  $line5 =~ m/ The Xj\(1\) coordinate is \[.+\]:(.+)/;
  $x = $x + $1;
  $line7 =~ m/ The Xj\(1\) coordinate is \[.+\]:(.+)/;
  $x = $x + $1;
  $x = $x/$nFiles;
  print MEAN_FID " The Xj(1) coordinate is [ 0.00000E+00]:   $x\n";

  #Deriv wrt xi1
  $x=0;
  $line1 = <LV1_FID>;
  $line4 = <LV4_FID>;
  $line5 = <LV5_FID>;
  $line7 = <LV7_FID>;
  $line1 =~ m/ The derivative wrt direction 1 is \[.+\]:(.+)/;
  $x = $x + $1;
  $line4 =~ m/ The derivative wrt direction 1 is \[.+\]:(.+)/;
  $x = $x + $1;
  $line5 =~ m/ The derivative wrt direction 1 is \[.+\]:(.+)/;
  $x = $x + $1;
  $line7 =~ m/ The derivative wrt direction 1 is \[.+\]:(.+)/;
  $x = $x + $1;
  $x = $x/$nFiles;
  print MEAN_FID " The derivative wrt direction 1 is [ 0.00000E+00]:   $x\n";

  #Deriv wrt xi2
  $x=0;
  $line1 = <LV1_FID>;
  $line4 = <LV4_FID>;
  $line5 = <LV5_FID>;
  $line7 = <LV7_FID>;
  $line1 =~ m/ The derivative wrt direction 2 is \[.+\]:(.+)/;
  $x = $x + $1;
  $line4 =~ m/ The derivative wrt direction 2 is \[.+\]:(.+)/;
  $x = $x + $1;
  $line5 =~ m/ The derivative wrt direction 2 is \[.+\]:(.+)/;
  $x = $x + $1;
  $line7 =~ m/ The derivative wrt direction 2 is \[.+\]:(.+)/;
  $x = $x + $1;
  $x = $x/$nFiles;
  print MEAN_FID " The derivative wrt direction 2 is [ 0.00000E+00]:   $x\n";

  #Deriv wrt xi1 and xi2
  $x=0;
  $line1 = <LV1_FID>;
  $line4 = <LV4_FID>;
  $line5 = <LV5_FID>;
  $line7 = <LV7_FID>;
  $line1 =~ m/ The derivative wrt directions 1 & 2 is \[.+\]:(.+)/;
  $x = $x + $1;
  $line4 =~ m/ The derivative wrt directions 1 & 2 is \[.+\]:(.+)/;
  $x = $x + $1;
  $line5 =~ m/ The derivative wrt directions 1 & 2 is \[.+\]:(.+)/;
  $x = $x + $1;
  $line7 =~ m/ The derivative wrt directions 1 & 2 is \[.+\]:(.+)/;
  $x = $x + $1;
  $x = $x/$nFiles;
  print MEAN_FID " The derivative wrt directions 1 & 2 is [ 0.00000E+00]:   $x\n";

  #Deriv wrt xi3
  $x=0;
  $line1 = <LV1_FID>;
  $line4 = <LV4_FID>;
  $line5 = <LV5_FID>;
  $line7 = <LV7_FID>;
  $line1 =~ m/ The derivative wrt direction 3 is \[.+\]:(.+)/;
  $x = $x + $1;
  $line4 =~ m/ The derivative wrt direction 3 is \[.+\]:(.+)/;
  $x = $x + $1;
  $line5 =~ m/ The derivative wrt direction 3 is \[.+\]:(.+)/;
  $x = $x + $1;
  $line7 =~ m/ The derivative wrt direction 3 is \[.+\]:(.+)/;
  $x = $x + $1;
  $x = $x/$nFiles;
  print MEAN_FID " The derivative wrt direction 3 is [ 0.00000E+00]:   $x\n";

  #Deriv wrt xi1 and xi3
  $x=0;
  $line1 = <LV1_FID>;
  $line4 = <LV4_FID>;
  $line5 = <LV5_FID>;
  $line7 = <LV7_FID>;
  $line1 =~ m/ The derivative wrt directions 1 & 3 is \[.+\]:(.+)/;
  $x = $x + $1;
  $line4 =~ m/ The derivative wrt directions 1 & 3 is \[.+\]:(.+)/;
  $x = $x + $1;
  $line5 =~ m/ The derivative wrt directions 1 & 3 is \[.+\]:(.+)/;
  $x = $x + $1;
  $line7 =~ m/ The derivative wrt directions 1 & 3 is \[.+\]:(.+)/;
  $x = $x + $1;
  $x = $x/$nFiles;
  print MEAN_FID " The derivative wrt directions 1 & 3 is [ 0.00000E+00]:   $x\n";

  #Deriv wrt xi2and xi3
  $x=0;
  $line1 = <LV1_FID>;
  $line4 = <LV4_FID>;
  $line5 = <LV5_FID>;
  $line7 = <LV7_FID>;
  $line1 =~ m/ The derivative wrt directions 2 & 3 is \[.+\]:(.+)/;
  $x = $x + $1;
  $line4 =~ m/ The derivative wrt directions 2 & 3 is \[.+\]:(.+)/;
  $x = $x + $1;
  $line5 =~ m/ The derivative wrt directions 2 & 3 is \[.+\]:(.+)/;
  $x = $x + $1;
  $line7 =~ m/ The derivative wrt directions 2 & 3 is \[.+\]:(.+)/;
  $x = $x + $1;
  $x = $x/$nFiles;
  print MEAN_FID " The derivative wrt directions 2 & 3 is [ 0.00000E+00]:   $x\n";

  #Deriv wrt xi1, xi2, and xi3
  $x=0;
  $line1 = <LV1_FID>;
  $line4 = <LV4_FID>;
  $line5 = <LV5_FID>;
  $line7 = <LV7_FID>;
  $line1 =~ m/ The derivative wrt directions 1, 2 & 3 is \[.+\]:(.+)/;
  $x = $x + $1;
  $line4 =~ m/ The derivative wrt directions 1, 2 & 3 is \[.+\]:(.+)/;
  $x = $x + $1;
  $line5 =~ m/ The derivative wrt directions 1, 2 & 3 is \[.+\]:(.+)/;
  $x = $x + $1;
  $line7 =~ m/ The derivative wrt directions 1, 2 & 3 is \[.+\]:(.+)/;
  $x = $x + $1;
  $x = $x/$nFiles;
  print MEAN_FID " The derivative wrt directions 1, 2 & 3 is [ 0.00000E+00]:   $x\n";

  return(1)
}


sub readApexMuandTheta
{
  my $n;
  for ($n=1; $n<24; $n++)
  {
    $line1 = <LV1_FID>;
    $line4 = <LV4_FID>;
    $line5 = <LV5_FID>;
    $line7 = <LV7_FID>;
    print MEAN_FID $line1;
  }

  return(1)
}


sub readMuandTheta
{
  my $x = 0;
  
  #Mu
  $x =0;
  $line1 = <LV1_FID>;
  $line4 = <LV4_FID>;
  $line5 = <LV5_FID>;
  $line7 = <LV7_FID>;
  $line1 =~ m/ The Xj\(2\) coordinate is \[.+\]:(.+)/;
  $x = $x + $1;
  $line4 =~ m/ The Xj\(2\) coordinate is \[.+\]:(.+)/;
  $x = $x + $1;
  $line5 =~ m/ The Xj\(2\) coordinate is \[.+\]:(.+)/;
  $x = $x + $1;
  $line7 =~ m/ The Xj\(2\) coordinate is \[.+\]:(.+)/;
  $x = $x + $1;
  $x = $x/$nFiles;
  print MEAN_FID " The Xj(2) coordinate is [ 0.00000E+00]:   $x\n";

  #Versions
  $line1 = <LV1_FID>;
  $line4 = <LV4_FID>;
  $line5 = <LV5_FID>;
  $line7 = <LV7_FID>;
  print MEAN_FID $line1;

  #Theta
  $x =0;
  $line1 = <LV1_FID>;
  $line4 = <LV4_FID>;
  $line5 = <LV5_FID>;
  $line7 = <LV7_FID>;
  $line1 =~ m/ The Xj\(3\) coordinate is \[.+\]:(.+)/;
  $x = $x + $1;
  $line4 =~ m/ The Xj\(3\) coordinate is \[.+\]:(.+)/;
  $x = $x + $1;
  $line5 =~ m/ The Xj\(3\) coordinate is \[.+\]:(.+)/;
  $x = $x + $1;
  $line7 =~ m/ The Xj\(3\) coordinate is \[.+\]:(.+)/;
  $x = $x + $1;
  $x = $x/$nFiles;
  print MEAN_FID " The Xj(3) coordinate is [ 0.00000E+00]:   $x\n";

  #Space
  $line1 = <LV1_FID>;
  $line4 = <LV4_FID>;
  $line5 = <LV5_FID>;
  $line7 = <LV7_FID>;
  print MEAN_FID $line1;

  return(1)
}




}
