# This file creates a new noise file
# Specify noise level and new noise-filename
# The perl-code is made similar to estimate.pl so it may look
# a little complicated, but this was done so it can be
# recognized and compared with estimate.pl


# Change these two variables to create a new noise file:
$noiseLevel = 0.00;
$noiseFile = "randomNoise000.txt";

use PDL;

$multFac = $noiseLevel/0.5;
$nDataPoints = 2880;
$y0 = zeroes(1,$nDataPoints);

CORE::open(RESULTFID, "> $noiseFile") || die "Couldn't open $noiseFile file";

if(1)
{
  #print RESULTFID "y0 without noise:", $y0;
  #print RESULTFID "\n******************************************************\n";
  #$meanStrain = avg(abs($y0-ones(1,$nDataPoints)));
  $y0 = addNoise($y0, $multFac);
}
CORE::close(RESULTFID);



# Subroutine addNoise
# This routine adds random noise to a column vector.
# The noise level is set by multFac.
sub addNoise
{
  my ($yIn, $multFac) = @_;
  my $nPoints = $yIn->getdim(1);
  my $noise = zeroes(1,$nPoints);  
  my $n;
    
  srand;
  for ($n = 0; $n < $nPoints; $n++)
  {
    PDL::Core::set $noise,0,$n,(((rand)-0.5)*$multFac);
  }
  print RESULTFID "\nNoise:", $noise;
  #print RESULTFID "\n******************************************************\n";
  # For testing:
  $nPoints--; #pga slice kommando m indeksen settes ned.
  #$meanNoise = avg($noise->slice("0,0:$nPoints"));
  #my $meanNoise = avg(abs($noise->slice("0,0:$nPoints")));
  
  #print RESULTFID "\nMean noise: $meanNoise\n";
  #my $stdv = std($noise->slice("0,0:$nPoints"));
  #print RESULTFID "Standard dev.: $stdv\n";
  #print RESULTFID "Minimum noise: ", min($noise);
  #print RESULTFID "\nMaximum noise: ", max($noise);
  #print RESULTFID "\n******************************************************\n";
  $nPoints++;
  return ($yIn+$noise);
}
