#****************************************************************************************************************************
# This command file controls the forward solution procedure. The optimiser MINLSSQP 
# send increments in material parameters to this file and thereby computes 
# the gradient of the objective function for the next optimisation step.
# The forward solution is started from the load step with initial
# material parameters by "fem solve incr 0" which saves to calculate the whole
# forward solve every time the optmiser calls this command file.
# It is then written into the proper array within CMISS for the residual calculation. 
#****************************************************************************************************************************

print " ================================================================================================ \n";
print " Iteration = ${ITERATION} \n";
print " ================================================================================================ \n";

#fem def init;r;trilin_NearlyInc_222cube_SS_BC
#fem def solve;r;trilin

#set output;solve on 
$number_load_steps=3;
for ($n=1;$n<=$number_load_steps;$n++)
{
	$p=5*$n;
	print "\n Increment: ", $n, "\n";
        fem def init;r;$example/222ForwardSolutionLoadPercent_$p
        fem def solve;r;trilin;example
  	fem solv iter 20 incr 0 #error 0.0000000000001
       
 	fem eval react nodes TOPFACE direction 1 residual 3*$n-2
	fem eval react nodes TOPFACE direction 2 residual 3*$n-1
	fem eval react nodes TOPFACE direction 3 residual 3*$n
}
#set output off

$ITERATION=$ITERATION+1;

#****************************************************************************************************************************
# 
#****************************************************************************************************************************
