
set num_threads 12;


$OUTPUT_DIR = "output/";
if( ! -d ${OUTPUT_DIR})
{
		mkdir ${OUTPUT_DIR};
}
#
$TRUE = 1;
$FALSE = 0;
#
# Solve for or read in deformations
#
$MAX_PRESS = 10;
$SOLVE_INFLATION = $TRUE;
$WALL = 1;





fem;
fem define para;r;heart;
fem define coord;r;rc3d            
fem define base;r;heart                               # Geometry and fibres
fem define;add bases;r;3Linear-2PressAuxXi3_3x3x3Gauss $WALL;   #9 Pressure
fem define node;r;refined
fem define element;r;refined
fem define fibre;r;refined
fem define element;r;refined fibre 


fem export nodes;heart as heart    #export nodes to cmgui
fem export elements;heart as heart #export elements to cmgui

fem group nodes 4,17,59,2 as some_base

fem group elements 3..8,13..18,21..30,63..68 as lv_epi
fem group elements 33..38,43..48,51..60,73..78 as lv_endo
fem group elements 31..32,39..42,49..50,71,72,79,80 as sept
fem group elements 1..2,9..12,19..20 as rv_free

fem group elements 63..68,71..80 as base
fem group elements 61,62,69,70 as base_rv
fem group elements 1..60 as ventricle 


fem define equation;r;finelas_tch_incomp region $WALL lock;

fem define material;r;heart gauss region $WALL;
fem define active;r;active0_00 region $WALL;
fem define initial;r;heart region $WALL;
fem define solve;r;newton region $WALL;




		print "\033[0;30;43m    Increase cavity pressures incrementally to simulate diastole    \033[0m\n"; 
    #
		set out;steps_inflate on;
		$NAME1 = "heart_def_00";
		$NAME2 = "_active_0000";
		$ITERS = 50;
		$TOL = 0.001;
		
		for $PRESS ( 0..10 ) 
		{
				if ($PRESS < 1) 
				{
						$FILENAME = ${NAME1}."0".${PRESS}.${NAME2}; 
            $INCREM = 0.0;
        } elsif ($PRESS < 10) {
		        $FILENAME = ${NAME1}."0".${PRESS}.${NAME2};
            $INCREM = 0.1;
        } else {
            $FILENAME = ${NAME1}.${PRESS}.${NAME2};
            $INCREM = 0.1;
        }

        fem solve increment $INCREM iter $ITERS error $TOL;
        fem define initial;w;${OUTPUT_DIR}.${FILENAME};
        #
       fem update gauss stress fibre components Piola;
       fem export gauss;${OUTPUT_DIR}.${FILENAME}."_gauss_stress" yg as gauss_stress;
       fem update gauss strain fibre components ;
       fem export gauss;${OUTPUT_DIR}.${FILENAME}."_gauss_strain" yg as gauss_strain;
        #
        fem export nodes;${OUTPUT_DIR}.${FILENAME}  as heart;
        fem export nodes;${OUTPUT_DIR}${FILENAME}_def field as heart;
        fem export elements;${OUTPUT_DIR}.${FILENAME} as heart;
        fem export elements;${OUTPUT_DIR}${FILENAME}_def field as wall;
    }


fem quit
