# Fit surface
fem define parameters;r;data;
fem define coor;r;3drc;

#
# The initial mesh
#
fem define bases;r;bicubic_fit;
fem def node;r;${SPECIMEN}.${SURFACE};
fem def elem;r;${SPECIMEN}.${SURFACE};
FEM group element all_elements as all

#fem up node deriv 1 linear
#fem up node deriv 2 linear
#fem up node deriv 3 linear
#
fem export node;${SPECIMEN}.${SURFACE}."_init" as ${SPECIMEN}.${SURFACE}."_init" offset 40000
fem export elem;${SPECIMEN}.${SURFACE}."_init" as ${SPECIMEN}.${SURFACE}."_init" offset_elem 40000
#
# Calculate the intial xi projections
#
fem def data;r;${SPECIMEN}.${SURFACE};
fem def xi;c close
fem li data err 
#fem export data;${SPECIMEN}.${SURFACE}."_data" as ${SPECIMEN}.${SURFACE}."_data" error
#
# Setup the fitting problem
#
fem up field from geometry
fem def fit;r;${SPECIMEN}.${SURFACE} geometry

#
# First fit
#
fem fit
fem update scale_factor normalise
fem update node fit

#
# Second fit
#
fem def xi;c close
fem li data err 
fem fit
fem update scale_factor normalise
fem update node fit

#
# Third fit
#
fem def xi;c close
fem li data err 
fem fit
fem update scale_factor normalise
fem update node fit

fem def xi;c close
fem li data err 
fem export data;${SPECIMEN}.${SURFACE}."_data" as ${SPECIMEN}.${SURFACE}."_data" error

#
# Export the fitted geometry
#
fem export node;${SPECIMEN}.${SURFACE} as ${SPECIMEN}.${SURFACE} offset 30000
fem export elem;${SPECIMEN}.${SURFACE} as ${SPECIMEN}.${SURFACE} offset_elem 30000

fem define nodes;w;${SPECIMEN}.${SURFACE}."_fitted"
fem define elements;w;${SPECIMEN}.${SURFACE}."_fitted"

quit