#
# Reads in a data set "goal" and transforms and scales to make a
#  dummy "measured" set. The files "basefile" and "infile" are
#  the companion files which are used by the rotate program.
#  Rotate needs the same numbers - and thus can't be read by CMGUI
#  without being overwritten. The control file tells which order
#  to match up the points - first 3 most important.
#
#  ~cmiss/bin/rotate -v -err 
#    basefile.exdata control.exdata infile.exdata outfile.exdata 
#
#  NOTE: the group name for outfile.exdata may need to be renamed.
#
#  With the transformation matrix (6 numbers)
#    Use ~cmiss/bin/transform to rotate other files
#
#

fem def coor 3,1

# Input data
#
fem def data;r;goal
fem export data;basefile as basefile offset 10000
fem export data;goal as goal offset 14000


# Transformed data
#
fem change data scale by 1.03,1.08,1.05
fem change data rotate by 20 about 1,0,0
fem export data;infile as infile offset 10000
fem export data;measured as measured offset 16000


quit
