fem def para;r;fitting_lin
fem def coor 3,1
fem def base;r;cubic_fit

#
# Reads in an initial mesh and calculates linear approximations
# for the derivatives in xi=1 direction
#
fem def node;r;mitral_valve_init
fem def elem;r;mitral_valve
fem up node deriv 1 linear
#
# The initial mesh
#
fem export node;mitral_valve_init as mitral_valve_init offset 20000
fem export elem;mitral_valve_init as mitral_valve_init offset_elem 20000


#
# Calculate the intial xi projections 
#   - alternatively the command fem def xi;c orthog can be used
#     it is slower but may produce better results in some cases
#
fem def data;r;mitral_valve_transformed
fem def xi;c close
fem li data err 
fem export data;mitral_valve_transformed_data as mitral_valve_transformed_data error
fem export data;mitral_valve_data_init as mitral_valve_data error


#
# Setup the fitting problem - 
#
fem up field from geometry

 
#
# Defines the fitting problem by setting smoothing parameters
#  and setting some fixed nodes.
#
fem def fit;r;mitral_valve geometry


#
# First fit
#
fem fit
fem update node fit
fem update scale_factor normalise
# The `old' option on `def xi;c' means that the last projections are used as
# initial estimates for the non-linear projection calculation.
fem def xi;c close old
fem li data err 

#
# Second fit
#
fem fit
fem update node fit
fem update scale_factor normalise
fem def xi;c close old
fem li data err 

#
# Third fit
#
fem fit
fem update node fit
fem update scale_factor normalise
fem def xi;c close old
fem li data err 


#
# Export the fitted geometry
#
fem export data;mitral_valve_data as mitral_valve_data error
fem export node;mitral_valve as mitral_valve offset 20000
fem export elem;mitral_valve as mitral_valve offset_elem 20000


fem define node;w;mitral_valve
