
  $EF_at_peak_P=55; #NB not the same as total EF that also include reduced ejection phase
  $V_at_peak_P = $V_ED*(100-$EF_at_peak_P)/100;

  $Psystole = 15; #kPa
  $Pee = 14; #kPa
  print "CA: $CA\n";
  $pIncr = 0.2; #kPa
  print "Pressure increment: $pIncr\n";
  $INCREM = $pIncr;


    #==========================================================================================================
    print "\033[0;30;42m ============================================================ \033[0m\n"; 
    print "\033[0;30;42m                     Solving Ejection                         \033[0m\n"; 
    print "\033[0;30;42m ============================================================ \033[0m\n"; 
    #==========================================================================================================
    #
    # Decrement the cavity pressures to simulate ejection
    #
    set output;${OUTPUT_DIR}steps_ejection on;
    #
    $ITER = 10;
    $ERROR_TOLERANCE = 0.01;
    print "\nLV pressure = $LV_PRESS\n\n";
    #fem solve increment 0 iter $ITER  error $ERROR_TOLERANCE;

    while ($LV_PRESS < $Psystole )
    {
      $LV_PRESS = $LV_PRESS + $INCREM;
      $V_of_P = MySubs::findVolumeGivenP($LV_PRESS,$DIASTOLIC_LV_CAVITY_VOLUME,$EF_at_peak_P);
      print "Solving for new LV_PRESS = $LV_PRESS\n"; 
      print "Volume for this pressure should be $V_of_P\n"; 
      fem solve increment $INCREM iter $ITER  error $ERROR_TOLERANCE;
      fem list elements deformed total cavity_volume region $LV_CAVITY;
      print "\nLV cavity volume = ${LV_CAVITY_VOLUME}\n";
      print "Volume for this pressure should be $V_of_P\n"; 
      $FILE = "fullheart_intermediate_ejection_active_".$CA."_press_";
      fem define initial;w;${OUTPUT_DIR}.${FILE}.${LV_PRESS} region $WALL

          $name = "heartEjection_".${LV_PRESS};
          $file = $output.$name
          fem export nodes;$file field as $name offset 0
          fem export elements;$file field as $name offset_elem 0
          $name = "heartEjectionStress_".${LV_PRESS}; 
          $file = $output.$name
          fem update gauss stress total Cauchy reg $WALL
          #fem update gauss stress total_no_hydro Piola reg $WALL
          fem export gauss;$file yg as gauss_stress offset 0 reg $WALL
          $name = "heartEjectionStrain_".${LV_PRESS};
          $file = $output.$name
          fem update gauss strain fibre extension_ratios reg $WALL
          fem export gauss;$file yg as gauss_strain reg $WALL

  # Remember to watch this that it actually reaches the desired volume
  # for each pressure increment.
  # May change code to increase CA steps as pressure gets close to max pressure 
      while ($LV_CAVITY_VOLUME > $V_of_P + $V_of_P+0.02)
      {
        print "Increasing calcium to reduce volume\n";
        $CA=$CA+0.5;
        MySubs::changeCalcium($CA/100);
        fem define active;r;${example}."calcium0xx" region $WALL;
        print "\033[0;30;43m                New Calcium Level = ${CA}                         \033[0m\n"; 
        fem solve increment 0 iter $ITER error $ERROR_TOLERANCE;
        $FILE = "fullheart_intermediate_ejection_active_".$CA."_press_";
        fem define initial;w;${OUTPUT_DIR}.${FILE}.${LV_PRESS} region $WALL
        #
          $name = "heartEjection_".${LV_PRESS};
          $file = $output.$name
          fem export nodes;$file field as $name offset 0
          fem export elements;$file field as $name offset_elem 0
          $name = "heartEjectionStress_".${LV_PRESS}; 
          $file = $output.$name
          fem update gauss stress total Cauchy reg $WALL
          #fem update gauss stress total_no_hydro Piola reg $WALL
          fem export gauss;$file yg as gauss_stress offset 0 reg $WALL
          $name = "heartEjectionStrain_".${LV_PRESS};
          $file = $output.$name
          fem update gauss strain fibre extension_ratios reg $WALL
          fem export gauss;$file yg as gauss_strain reg $WALL
        #
        fem list elements deformed total cavity_volume region $LV_CAVITY;
        print "\nLV cavity volume = ${LV_CAVITY_VOLUME}\n";
        print "Volume for this pressure should be $V_of_P\n"; 
        print "LV pressure = $LV_PRESS\n";
        print "Solved for Calcium level = $CA\n\n";
      }
      $FILE = "fullheart_def_ejection_active_".$CA."_press_";
      fem define initial;w;${OUTPUT_DIR}.${FILE}.${LV_PRESS} region $WALL
    }

  
  fem define initial;w;${OUTPUT_DIR}.${FILE}.${LV_PRESS}."EndEjection" region $WALL
      
  $name = "heartEjection_".${LV_PRESS};
  $file = $output.$name
  fem export nodes;$file field as $name offset 0
  fem export elements;$file field as $name offset_elem 0
  $name = "heartEjectionStress_".${LV_PRESS}; 
  $file = $output.$name
  fem update gauss stress total Cauchy reg $WALL
  #fem update gauss stress total_no_hydro Piola reg $WALL
  fem export gauss;$file yg as gauss_stress offset 0 reg $WALL
  $name = "heartEjectionStrain_".${LV_PRESS};
  $file = $output.$name
  fem update gauss strain fibre extension_ratios reg $WALL
  fem export gauss;$file yg as gauss_strain reg $WALL
 
