  if($CELL_MODEL eq "FM_GAUSS") 
  {
    fem define material;r;${example}polezero_gauss region $WALL;
    MySubs::changeCalcium(0);
    fem define active;r;${example}."calcium0xx" region $WALL;
    #fem define active;r;${example}active0_0 region $WALL;
    # Isovolumically contract the ventricles by incrementally
    # increasing intracellular calcium concentration and solving.
    # If the cavity volume decreases, increment the cavity pressure
    # and resolve for the same activation level.
    #
    $NAME2 = "fullheart_def_active_";
    $ITER = 20;
    $ERROR_TOLERANCE = 0.001;
    $CA = 0;
    $PstartEjection = 10 # kPa
    #
    $SOLVEAGAIN = 0;
    while (($LV_PRESS < $PstartEjection ) || ($SOLVEAGAIN))
    {
        print "\033[0;30;43m                    Calcium Level = ${CA}                         \033[0m\n"; 
        $FILE=${NAME2}.${CA};
        #
        MySubs::changeCalcium($CA/100);
        fem define active;r;${example}."calcium0xx" region $WALL;
        #fem define active;r;${example}.${NAME1}.${CA} region $WALL;
        fem solve increment 0.0 iter $ITER  error $ERROR_TOLERANCE;
        fem define initial;w;${OUTPUT_DIR}.${FILE} region $WALL
        #
  $name = "heartIVCCalcium_".${CA};
  $file = $output.$name
  fem export nodes;$file field as $name offset 0
  fem export elements;$file field as $name offset_elem 0
  $name = "heartIVCCalciumStress_".${CA}; 
  $file = $output.$name
  fem update gauss stress total Cauchy reg $WALL
  #fem update gauss stress total_no_hydro Piola reg $WALL
  fem export gauss;$file yg as gauss_stress offset 0 reg $WALL
  $name = "heartIVCCalciumStrain_".${CA};
  $file = $output.$name
  fem update gauss strain fibre extension_ratios reg $WALL
  fem export gauss;$file yg as gauss_strain reg $WALL
        #
        fem list elements deformed total cavity_volume region $LV_CAVITY;
        fem list elements deformed total cavity_volume region $RV_CAVITY; 
        print "\nLV cavity volume = ${LV_CAVITY_VOLUME}\n";
        print "RV cavity volume = ${RV_CAVITY_VOLUME}\n\n";
        print "LV pressure: $LV_PRESS kPa\n";
        print "RV pressure: $RV_PRESS kPa\n\n";
        #
        if ($LV_CAVITY_VOLUME < ($DIASTOLIC_LV_CAVITY_VOLUME-$DIASTOLIC_LV_CAVITY_VOLUME*0.01) )
        {
            $INCREM = 0.1;
	    fem update pressure boundary elements LV_FREE_WALL auxillary 1 increment $INCREM;
	    fem update pressure boundary elements SEPTUM auxillary 1 increment $INCREM;
            $LV_PRESS = $LV_PRESS+$INCREM;
            print "\nIncreasing LV cavity pressure by $INCREM to $LV_PRESS kPa\n\n";
            $SOLVEAGAIN = 1;
        } elsif ($RV_CAVITY_VOLUME < ($DIASTOLIC_RV_CAVITY_VOLUME-$DIASTOLIC_RV_CAVITY_VOLUME*0.01) )
        {
            $INCREM = 0.1;
	    fem update pressure boundary elements SEPTUM auxillary 2 increment $INCREM;
	    fem update pressure boundary elements RV_FREE_WALL auxillary 1 increment $INCREM;
            $RV_PRESS = $RV_PRESS+$INCREM*0.2;
            print "\nIncreasing RV cavity pressure by $INCREM to $RV_PRESS kPa\n\n";
            $SOLVEAGAIN = 1;
        } else {
            if($CA>=35)
            {
              $CA=$CA+0.5;
            } else
            {
              $CA++;
            }
            $SOLVEAGAIN = 0;
        }
        #
    }
    #
    print "Total LV cavity pressure = $LV_PRESS\n";
    print "Total RV cavity pressure = $RV_PRESS\n";
    print "End-diastolic LV cavity volume = ${DIASTOLIC_LV_CAVITY_VOLUME}\n";
    print "End-isovolumic contraction LV cavity volume = ${LV_CAVITY_VOLUME}\n\n";
    print "End-diastolic RV cavity volume = ${DIASTOLIC_RV_CAVITY_VOLUME}\n";
    print "End-isovolumic contraction RV cavity volume = ${RV_CAVITY_VOLUME}\n\n";
    #

  } 
  
