#==========================================================================================================
print "\033[0;30;42m ============================================================ \033[0m\n"; 
print "\033[0;30;42m                    Rapid Recoil phase                       \033[0m\n"; 
print "\033[0;30;42m ============================================================ \033[0m\n"; 
#==========================================================================================================

#decrease ca by -1 until 14 -> 12 -> 8 - > 0
$CA=$CA+1; #solveRecoil subtracts 1 at the end
print "Current calcium: $CA\n";
$CA=int($CA+0.5);
print "Calcium rounded off to: $CA\n";
$nIter = int($CA-14)+3;
print "Iterations to reach 0 calcium: $nIter\n";
$pIncrLV = (0.0-$LV_PRESS)/($nIter); #kPa
$pIncrRV = (0.0-$RV_PRESS)/($nIter); #kPa
print "LV Pressure increment: $pIncrLV\n";
print "RV Pressure increment: $pIncrRV\n";

#fem solve increment 0 iter $iterations error 1.0e-1
$ITER = 10;
$ERROR_TOLERANCE = 0.01;

for($n=1;$n<=$nIter;$n++)
{
  if($CA>14)
  {
    $CA = $CA-1;
  } elsif($CA==14)
  {
    $CA = 12;
  } elsif($CA==12)
  {
    $CA = 8;
  } elsif($CA==8)
  {
    $CA = 0;
  }  
  print "\033[0;30;43m                    Calcium Level = ${CA}                         \033[0m\n"; 
  MySubs::changeCalcium($CA/100);
  fem define active;r;${example}."calcium0xx" region $WALL;

  $INCREM = $pIncrLV;
  fem update pressure boundary elements LV_FREE_WALL auxillary 1 increment $INCREM;
  fem update pressure boundary elements SEPTUM auxillary 1 increment $INCREM;
  $LV_PRESS = $LV_PRESS+$pIncrLV;
  print "\nIncreasing LV cavity pressure by $pIncrLV to $LV_PRESS kPa\n\n";
  $INCREM = $pIncrRV/0.2;
  fem update pressure boundary elements SEPTUM auxillary 2 increment $INCREM;
  fem update pressure boundary elements RV_FREE_WALL auxillary 1 increment $INCREM;
  $RV_PRESS = $RV_PRESS+$pIncrRV;
  print "\nIncreasing RV cavity pressure by $pIncrRV to $RV_PRESS kPa\n\n";

  fem solve increment 0.0 iter $ITER error $ERROR_TOLERANCE;
  $FILE = "fullheart_def_rapid_active_".$CA;
  fem define initial;w;${OUTPUT_DIR}.${FILE} region $WALL

  fem list elements deformed total cavity_volume region $LV_CAVITY;
  fem list elements deformed total cavity_volume region $RV_CAVITY; 
  print "\nLV cavity volume = ${LV_CAVITY_VOLUME}\n";
  print "RV cavity volume = ${RV_CAVITY_VOLUME}\n\n";
  print "LV pressure: $LV_PRESS kPa\n";
  print "RV pressure: $RV_PRESS kPa\n\n";

  $name = "heartRapid_".${CA};
  $file = $output.$name
  fem export nodes;$file field as $name offset 0
  fem export elements;$file field as $name offset_elem 0
  $name = "heartRapidStress_".${CA}; 
  $file = $output.$name
  fem update gauss stress total Cauchy reg $WALL
  #fem update gauss stress total_no_hydro Piola reg $WALL
  fem export gauss;$file yg as gauss_stress offset 0 reg $WALL
  $name = "heartRapidStrain_".${CA};
  $file = $output.$name
  fem update gauss strain fibre extension_ratios reg $WALL
  fem export gauss;$file yg as gauss_strain reg $WALL
}

$CA=0;
print "\033[0;30;43m                   Last solve                         \033[0m\n"; 
print "\033[0;30;43m                    Calcium Level = ${CA}                         \033[0m\n"; 
MySubs::changeCalcium($CA/100);
fem define active;r;${example}."calcium0xx" region $WALL;
fem solve increment 0 iter 20 error 1e-10;

$name = "heartEndCycle";
$file = $output.$name
fem export nodes;$file field as $name offset 2000
fem export elements;$file field as $name offset_elem 2000
$FILE = "fullheart_def_endCycle";
fem define initial;w;${OUTPUT_DIR}.${FILE} region $WALL

