# Example 811f


set num_threads 4
use MyFunc;

$INFLATION = 1;
$IVC = 1;
$EJECTION = 1;
$REDUCED = 1;
$IVR = 1;
$RECOIL = 1;

$output = "./output/"
$outputInit = "./outputInit/"
if( ! -d ${output})
{
    mkdir ${output};
}
if( ! -d ${$outputInit})
{
    mkdir ${outputInit};
}

# Regions
$WALL = 1;
$LV_CAVITY = 3; #This needs to be 3 due to some hack in cmiss that only changes the cavity volume variable for region 3
$iterations = 30

$PstartEjection = 8 # kPa
$Psystole = 9.5; #kPa
$Pee = 8.75; #kPa
$Pla = 1; #kPa

$TRUE=1;
$FALSE=0;
$time = 1;


fem def param;r;full_big
fem define coor;r;rcCoord reg $WALL
fem define base;r;basisfuncs
#
fem define nodes;r;finalMeshRefined reg $WALL
fem define elements;r;finalMeshRefined reg $WALL
fem define fibre;r;fibresRefined reg $WALL
fem define element;r;fibresRefined fibre reg $WALL
$name = "heartOriginal"
$file = $output.$name
fem export nodes;$file as $name offset 0000
fem export elements;$file as $name offset_elem 0000
  
# Material groups
fem group nodes 1,18,35,52 as apexNodes
fem group nodes 2..5,19..22,36..39,53..56 as subApexNodes
fem group nodes 6..17,23..34,40..51,57..68 as normalNodes
fem group nodes 14..17,31..34,48..51,65..68 as baseNodes
# Boundary Condition groups
fem group nodes 1,18,35,52 as fixedApexNodes
fem group nodes 14..17,31..34,48..51,65..68 as fixedBaseNodes
fem group nodes 14,16 as y_axisNodes
fem group nodes 15,17 as z_axisNodes
# Residual strains groups
fem group nodes 6..13 as nodes095
fem group nodes 40..47 as nodes098
fem group nodes 1..5,14..22,31..39,48..56,65..68 as nodes100
fem group nodes 57..64 as nodes103
fem group nodes 23..30 as nodes105
#
fem define equation;r;equation reg $WALL lock
fem define material;r;inhomo_nodes reg $WALL
$return = MyFunc::changeCalcium(0);
fem define active;r;calcium0xx

fem define initial;r;x_Base_node_restricted reg $WALL
fem define solve;r;solve reg $WALL

#####################################################################
if ($INFLATION)
{
  read com;solveInflation
} else
{
  fem define initial;r;$output."wall_inflated_Anode" reg $WALL
  fem define solve;r;solve reg $WALL
  #fem solve increment 0.0
}
$name = "heartInflated"
$file = $output.$name
fem export nodes;$file field as $name offset 2000
fem export elements;$file field as $name offset_elem 2000
if(0)
{
  fem update geometry from solution
  $name = "heartInflated"
  $file = $output.$name
  fem define nodes;w;$file reg $WALL
}


#die("Stop")
#####################################################################
if($IVC || $EJECTION)
{
  # Set up cavity region geometry
  fem define region;r;regions
  fem define coord;r;cavityCoord region $LV_CAVITY
  fem define node;r;cavity region $LV_CAVITY
  fem define element;r;cavity2 region $LV_CAVITY

  fem list elements deformed total cavity_volume region $LV_CAVITY; # Defines and sets the var $LV_CAVITY_VOLUME
  # This function should ideally have worked, but it was a qwuick hack made for the pig heart (ecample_811d) and
  # work needs to be done in OPELEM.f to make it more general and make sure the calculated volume is the
  # same as for the "fem list element deformed total region $LV_CAVITY" further down.
  print "\nLV cavity volume = ${LV_CAVITY_VOLUME}\n";
  $DIASTOLIC_LV_CAVITY_VOLUME = $LV_CAVITY_VOLUME;

  $name = "cavityOriginal"
  $file = $output.$name
  fem export nodes;$file as $name offset 0 reg $LV_CAVITY
  fem export elements;$file as $name offset_elem 0 reg $LV_CAVITY
}

if($IVC)
{
  read com;solveIVC
} else
{
  #die("");
  $Cactn = MyFunc::findCalcium($output."calciumEndIVC.ipacti");
  print "Calcium after IVC: $Cactn\n";
  fem define active;r;$output."calciumEndIVC"
  fem define initial;r;$output."wall_endIVC" region $WALL
  fem define initial;w;$output."temp" region $WALL
  $return = MyFunc::editInitFile(0.3);
  fem define initial;r;$output."ejection" reg $WALL
  fem define solve;r;solve reg $WALL
  fem eval resid wrt geom reg $WALL
  #fem solve increment 0.0 iter 20 error 1.0e-1
  $return = MyFunc::editInitFile(1);
  fem define initial;r;$output."ejection" reg $WALL
} # if $IVC
$name = "heartIVC"
$file = $output.$name
fem export nodes;$file field as $name offset 3000
fem export elements;$file field as $name offset_elem 3000
if(0)
{
  fem update geometry from solution
  $name = "heartIVC"
  $file = $output.$name
  fem define nodes;w;$file reg $WALL
}


#die("")
#####################################################################
if($EJECTION)
{
  read com;solveEjection
} else
{
  $Cactn = MyFunc::findCalcium($output."calciumEndRapidEjection.ipacti");
  print "Calcium = ", $Cactn, "\n";
  $return = MyFunc::changeCalcium($Cactn);
  fem define active;r;"calcium0xx"
  #fem define active;r;"calcium100"
  fem define initial;r;$output."endRapidEjection" region $WALL
  fem define initial;w;$output."temp" region $WALL
  $return = MyFunc::editInitFile(0);
  fem define initial;r;$output."ejection" reg $WALL
  fem define solve;r;solve reg $WALL
  fem eval resid wrt geom reg $WALL
  #fem solve increment 0.0 iter 20 error 1.0e-1
} # if $EJECTION
$name = "heartRapidEjection"
$file = $output.$name
fem export nodes;$file field as $name offset 4000
fem export elements;$file field as $name offset_elem 4000
if(0)
{
  fem update geometry from solution
  $name = "deformedEndEjection"
  $file = $output.$name
  fem define nodes;w;$file reg $WALL
}

if($REDUCED)
{
  read commands;${example}solveReduced; 
} else
{
  $Cactn = MyFunc::findCalcium($output."calciumEndEjection.ipacti");
  print "Calcium = ", $Cactn, "\n";
  $return = MyFunc::changeCalcium($Cactn);
  fem define active;r;$output."calciumEndEjection"
  fem define initial;r;$output."endEjection" region $WALL
  #fem define initial;w;$output."temp" region $WALL
  #$return = MyFunc::editInitFile(0);
  #fem define initial;r;$output."ejection" reg $WALL
  fem define solve;r;solve reg $WALL
  #fem define nodes;r;finalMeshRefined reg $WALL
  fem eval resid wrt geom reg $WALL
  #die("");
  #fem solve increment 0.0 iter 20 error 1.0e-1
} # if $EJECTION
$name = "heartReducedEjection"
$file = $output.$name
fem export nodes;$file field as $name offset 5000
fem export elements;$file field as $name offset_elem 5000
$name = "heartEndEjection"
$file = $output.$name
fem export nodes;$file field as $name offset 5000
fem export elements;$file field as $name offset_elem 5000




#die("");
#####################################################################
if($IVR)
{
  read com;solveIVR
} else
{
  fem define active;r;$output."calciumEndIVR"
  fem define initial;r;$output."wall_endIVR" region $WALL
  fem define initial;w;$output."temp" region $WALL
  $return = MyFunc::editInitFile(0);
  fem define initial;r;$output."ejection" reg $WALL
  fem define solve;r;solve reg $WALL
  fem eval resid wrt geom reg $WALL
}

$name = "heartIVR"
$file = $output.$name
fem export nodes;$file field as $name offset 6000
fem export elements;$file field as $name offset_elem 6000

  
if($RECOIL)
{  
  read com;solveRecoil
}

$name = "heartEndCycle"
$file = $output.$name
fem export nodes;$file field as $name offset 7000
fem export elements;$file field as $name offset_elem 7000


