#==========================================================================================================
print "\033[0;30;42m ============================================================ \033[0m\n"; 
print "\033[0;30;42m                    Rapid Recoil phase                       \033[0m\n"; 
print "\033[0;30;42m ============================================================ \033[0m\n"; 
#==========================================================================================================

  $Cactn = MyFunc::findCalcium($output."calciumEndIVR.ipacti");
  print "Calcium = ", $Cactn, "\n";
  fem define initial;w;$output."temp" region $WALL
  $Plv = MyFunc::readPressure($output."temp.ipinit");
  print "LV Pressure: ", $Plv, "\n";
  
  $Cactn=int(100*$Cactn+0.5)/100;
  print "Calcium rounded off to: $Cactn\n";
  $nIter = int($Cactn*100-14)+3;
  print "Iterations to reach 0 calcium: $nIter\n";
  $pIncr = (0.0-$Plv)/($nIter); #kPa
  print "Pressure increment: $pIncr\n";
  print "Iterations: $nIter\n";

  $return = MyFunc::editInitFile(1);
  fem define initial;r;"$output/ejection" reg $WALL
  fem define solve;r;solve reg $WALL
  fem solve increment 0 iter $iterations
  #fem solve increment 0 iter $iterations error 1.0e-1

  $Plv = MyFunc::readPressure($output."temp.ipinit");
  print "LV Pressure: ", $Plv, "\n";

$LV_PRESS = $Plv;
for($n=1;$n<=$nIter;$n++)
{
  if($Cactn>0.14)
  {
    $Cactn = $Cactn-0.01;
  } elsif(($Cactn<=0.141) && ($Cactn>=0.139))
  {
    $Cactn = 0.12;
    print "Ca set to $Cactn\n";
  } elsif($Cactn==0.12)
  {
    $Cactn = 0.08;
    print "Ca set to $Cactn\n";
  } elsif($Cactn==0.08)
  {
    $Cactn = 0;
    print "Ca set to $Cactn\n";
  }  
  print "\033[0;30;43m                    Calcium Level = $Cactn                         \033[0m\n"; 
  $return = MyFunc::changeCalcium($Cactn);
  fem define active;r;"calcium0xx"
  $LV_PRESS = $LV_PRESS+$pIncr;
  print "\nDecreasing LV cavity pressure by $pIncr to $LV_PRESS kPa\n\n";
  fem solve increment $pIncr iter $iterations error 1.0e-1
  fem define initial;w;$outputInit."lv_def_recoil_$time" reg $WALL
  $return = MyFunc::writeCalciumLevel($Cactn,$time);
  $time=$time+1;
  fem define initial;w;$output."temp" region $WALL

  read com;export
  
  fem list elements deformed total cavity_volume region $LV_CAVITY;
  print "\nLV cavity volume = ${LV_CAVITY_VOLUME}\n";
  
  $name = "heartRapid_".${Cactn};
  $file = $output.$name
  fem export nodes;$file field as $name offset 0
  fem export elements;$file field as $name offset_elem 0
  $name = "heartRapidStress_".${Cactn}; 
  $file = $output.$name
  fem update gauss stress total Cauchy reg $WALL
  #fem update gauss stress total_no_hydro Piola reg $WALL
  fem export gauss;$file yg as gauss_stress offset 0 reg $WALL
  $name = "heartRapidStrain_".${Cactn};
  $file = $output.$name
  fem update gauss strain fibre extension_ratios reg $WALL
  fem export gauss;$file yg as gauss_strain reg $WALL
}

  fem define initial;w;$output."temp" region $WALL
  $Plv = MyFunc::readPressure($output."temp.ipinit");
  print "LV Pressure: ", $Plv, "\n";
  $Cactn = MyFunc::findCalcium("calcium0xx.ipacti");
  print "Calcium = ", $Cactn, "\n";
