#Example_94  Gas mixing in an asymmetric conducting airway/LPM model
#This example simulates mixing of sulpherhexafloride with nitrogen
#in a full lung model.  The conducting airways are asymmetric, grown
#as described in example 93.  Each terminal conducting airway branch is
#attached to a lumped parameter model of the acinus as described in 
#example 92.

fem de param;r;acalpm;example
fem de coor;r;acalpm;example
fem de base;r;acalpm;example            #linear basis function, 4 gp
fem de node;r;acalpm;example binary     #define model nodes
fem de elem;r;acalpm;example binary     #define model elements
fem de mesh;r;acalpm;example            #define full lung model
fem de equa;r;acalpm;example            #advection-diffusion equation
fem de moti;c lung tidal 0.1 Tinsp 0.2 Bhold 0 Texpn 0.2 constant;
fem de mate;r;acalpm;example            #SF6/N2
fem de init;c lung conc_in 1.0 initial 0.0
fem de solve;r;acalpm;example           #solved using Lagrange-Galerkin
fem solve from 0 to 0.4 delta_t 0.05


