#Solve the coupled LR-HMT model for a single cell.

#set up problem size
fem define para;r;test;example
 
#Define geometry of the problem
#  Define underlying geometry
fem define base;d
fem define node;d
fem define elem;d
#  Define grid geometry
fem define grid;d
fem update grid geometry
fem update grid metric
 
#Define equation to solve
#  define a time integration of the cellular based coupled user defined
#  model 2 (LR-HMT) using monodomain.
fem define equa;r;test;example
 
#Define material properties for the problem
 
#  Define cellular material properties
fem define cell;r;lr_hmt;example
#    Define cell variants and spatially varying material parameters
fem define mate;r;test;example cell
#  Define the continuum material parameters
fem define mate;r;test;example
#fem update grid material

#Define the time variable to be used to specify the time varying boundary
#condition imposed on the extension ratio
fem def time;r;step;example
 
#Define continuum initial conditions
#  Set no-flux boundary condition, and time varying extension ratio
fem define init;r;test;example
 
#Define the explicit solve, using the adams integrator
fem def solv;r;test;example
 
#Solve the problem
 
#  Set the number of threads to use when using a multiprocessing
#  executable
set num_threads 16
 
#  Initialise the solve
fem solve to 0
 
#  Open a binary history file - see cell_user2.inc for variable definitions
fem open history;test write variables yqs niqslist 1,3,15,16,17,18 binary
 
#  Loop through time

# Command updated by fixcom.sh on Wed Aug 23 17:49:43 NZT 2000
# Old command: DO HUN=0..2
for $HUN ( 0..2 ) 
{


# Command updated by fixcom.sh on Wed Aug 23 17:49:43 NZT 2000
# Old command: DO TEN=0..9
for $TEN ( 0..9 ) 
{


# Command updated by fixcom.sh on Wed Aug 23 17:49:43 NZT 2000
# Old command: DO UNIT=0..9
for $UNIT ( 0..9 ) 
{

 
#  Solve for the current time

# Command updated by fixcom.sh on Wed Aug 23 17:49:43 NZT 2000
# Old command:   fem solve restart to $HUN//$TEN//$UNIT
fem solve restart to "${HUN}${TEN}$UNIT"

 
#  Write the membrane potential to the history file

# Command updated by fixcom.sh on Wed Aug 23 17:49:43 NZT 2000
# Old command:   fem write history time $HUN//$TEN//$UNIT variables yqs binary
fem write history time "${HUN}${TEN}$UNIT" variables yqs binary

 

# Command updated by fixcom.sh on Wed Aug 23 17:49:43 NZT 2000
# Old command: ENDDO
}



# Command updated by fixcom.sh on Wed Aug 23 17:49:43 NZT 2000
# Old command: ENDDO
}



# Command updated by fixcom.sh on Wed Aug 23 17:49:43 NZT 2000
# Old command: ENDDO
}


 
#  Close the history file
fem close history binary
