
################################################

# Define parameters,regions,and coordinate system
fem def para;r;contact;example
fem def region;r;contact;example
fem def coord 3,1

#Read in deformable body
fem def nodes;r;rectus;example 
fem def bases;r;collapsed;example 
fem def elements;r;rectus;example

# Define fibre field (nj 4,5,6)
fem def fibre;r;rectus;example 
fem def elements;r;rectus;example fibre

# Export initial rectus muscle
#fem exp nodes;rectus_ref as rectus_ref
#fem exp elements;rectus_ref as rectus_ref 

# Read in target
fem def node;r;target;example region 2 
fem def element;r;target;example region 2

# Define target fibre field (nj 4,5,6)
fem def fibre;r;target;example reg 2 
fem def elements;r;target;example fibre reg 2

# Export target
#fem exp nodes;target as target region 2
#fem exp elem;target as target region 2 

fem group nodes 29,30,31,32,40,1,2,3,4,33 as FIXALL reg 1
fem group nodes 39,27,38,24,37,19,36,15,35,11,34,7 as FIXXY reg 1

# Method
fem def equa;r;rectus;example
fem def mate;r;rectus;example 
fem def init;r;rectus;example 
  
# Method (Target)
fem def equa;r;target;example reg 2
fem def mate;r;target;example reg 2 
fem def init;r;target;example reg 2

# Define solve for region 1 only
fem def solve;r;rectus;example reg 1

$CONVERGED=0;
while ($CONVERGED==0) 
#for($i=1;$i<2;$i++)
{
######################################Projection

# Set contact Xi points on specified faces as 8x8 points
fem def xi;c contact_points faces 55,58,61,66 points 8 reg 1

# Define data at xi positions 
fem def data;c from_xi

# Update slave info
fem update data field to slave

# Project onto target face (Region 2 face 91)
fem def xi;c closest_face faces 91 region 2
 
# store projection gap in data fields
fem update data field from gap region 2  

# Update master info
fem update data field to master 

# Place initial geometry YP(ny,3) into XP
FEM up geom from sol YP_index 3 to 1..3 reg 1

#####################################Mechanics problem

# Solve finite elasticity/contact problem
fem solve error 1.0D-03 iterate 22 AUGMENTATIONS 0 CONTACT_STIFFNESS 1.0 TIED_STIFFNESS 1.0 reg 1

# update XP from YP
FEM up geom from sol to 1..3 reg 1

}

# Export final deformed mesh 
#fem exp nodes;rectus_def as rectus_def offset 300
#fem exp elements;rectus_def as rectus_def offset_elem 300
#fem exp nodes;target_def as target_def offset 400 reg 2
#fem exp elements;target_def as target_def offset_elem 400 reg 2









