
# Define parameters,regions,and coordinate system
fem def para;r;contact;example
fem def region;r;contact;example
fem def coord 3,1
fem def bases;r;collapsed;example

$REG=1;
######################################################muscles
# muscle_list
@muscle_list = ('rectus');
foreach $component (@muscle_list)
{ 
#Read in muscle
fem def nodes;r;simulate_$component;example  reg $REG
fem def elements;r;simulate_$component;example  reg $REG

# Define muscle fibre field (nj 4,5,6)
fem def fibre;r;simulate_$component;example reg $REG
fem def elements;r;simulate_$component;example fibre reg $REG

if ($REG==1){fem group nodes 3005..3044 as RECTUSNODES reg $REG}
if ($REG==1){fem group nodes 3001..3004,3045 as RECTUSFIXED reg $REG}
if ($REG==1){fem group nodes 3036,3030,3027,3024,3019,3015,3011,3007,3003 as RECTUSFIXEDXY reg $REG}

# Muscle (active contraction + contact option)
fem def equa;r;simulate_$component;example reg $REG
fem def mate;r;simulate_$component;example reg $REG
fem def init;r;simulate_$component;example reg $REG
fem def acti;r;simulate_$component;example reg $REG 

# Export initial muscle
#fem exp nodes;init_simulate_$component as $component reg $REG
#fem exp elements;init_simulate_$component as $component reg $REG
$REG=$REG+1;
}

#######################################################bones
# bone_list
@bone_list = ('patella');
foreach $component(@bone_list)
{ 
# Read in bone
fem def node;r;simulate_$component;example region $REG 
fem def element;r;simulate_$component;example region $REG

# Define bone fibre field (nj 4,5,6)
fem def fibre;r;simulate_$component;example reg $REG 
fem def elements;r;simulate_$component;example fibre reg $REG

if ($REG==2){fem group nodes 2001..2047 as PATELLANODES reg $REG}

# bone (only contact option)
fem def equa;r;simulate_$component;example reg $REG
fem def mate;r;simulate_$component;example reg $REG
fem def init;r;simulate_$component;example reg $REG

# Export initial bone
#fem exp nodes;init_simulate_$component as $component region $REG
#fem exp elem;init_simulate_$component as $component region $REG
$REG=$REG+1;
}
#######################################################

# Define solve for coupled
fem def solve;r;contact;example coupled reg 1,2

$CONVERGED=0;
while($CONVERGED==0)
#for($j=1;$j<2;$j++)
{
# Set contact Xi points on specified faces as 8x8 points
fem def xi;c contact_tied faces 99,96,89,93 points 8 reg 1

# Define data at xi positions 
fem def data;c from_xi

# Update slave info
fem update data field to slave

# Project onto target face (master surface)
#fem group faces 218,220,200,203,215,235,236,223,225,227,229,231,233 as PATELLAFACES reg 2
#fem def xi;c closest_face faces PATELLAFACES region 2 
#fem def xi;w;target closest_face region 2 

fem def xi;r;target;example closest_face region 2 

# store projection gap in data fields
fem update data field from gap region 2  

# Update master info
fem update data field to master 

# Place initial geometry YP(ny,3) into XP
FEM up geom from sol YP_index 3 to 1..3 reg 1,2

#####################################Mechanics problem

# Solve finite elasticity/contact problem
fem solve error 1.0D-03 iterate 10 coupled AUGMENTATIONS 0 CONTACT_STIFFNESS 1.0 TIED_STIFFNESS 1.0 reg 1,2

# update XP from YP
FEM up geom from sol to 1..3 reg 1,2

}

# Export final deformed mesh 
#$REG=1;
# solution_list
#@solution_list = ('rectus','patella');
#foreach $component(@solution_list)
#{
#fem exp nodes;def_$component as $component region $REG
#fem exp elem;def_$component as $component region $REG
#$REG=$REG+1;
#}




