#
# This example illustrates customisation of the rectus femoris muscle derived  
# from the visible man to a rectus muscle from the visible women.
#

# Define variables
$SLAVE= "rectus_slave"
$CUST_SLAVE = "rectus_cust"
$HOST = "host"
$CUST_HOST = "host_cust"
$LANDMARK = "rectus_landmark"
$TARGET = "rectus_projection"
$HOST_REG = 2
$SLAVE_REG= 1

fem def para;r;fitting;example #fitting parameters
fem def regi;r;two;example #2 regions
fem def coor 3,1 #3D rectangular cartesian
fem def base;r;collapsed;example # bases functions

###################################################

# The slave mesh
fem def node;r;$SLAVE;example reg $SLAVE_REG
fem def elem;r;$SLAVE;example reg $SLAVE_REG
#fem export node;$SLAVE as $SLAVE reg $SLAVE_REG
#fem export elem;$SLAVE as $SLAVE reg $SLAVE_REG

###################################################

# The host mesh
fem def node;r;$HOST;example reg $HOST_REG
fem def elem;r;$HOST;example reg $HOST_REG
fem up node deriv 1 reg $HOST_REG
fem up node deriv 2 reg $HOST_REG
fem up node deriv 3 reg $HOST_REG

# Refine host mesh
fem ref xi 3 elements 101 at 0.25 reg $HOST_REG
fem ref xi 3 elements 102 at 0.67 reg $HOST_REG 
#fem export node;$HOST as $HOST reg $HOST_REG
#fem export elem;$HOST as $HOST reg $HOST_REG

###################################################

# Calculate xi's for generic data points
fem def data;r;$LANDMARK;example
fem def xi;c contain reg $HOST_REG
#fem export data;$LANDMARK as $LANDMARK error
#fem def xi;w;$LANDMARK reg $HOST_REG

# Calculate xi's for node points
fem def xi;c nodes contain of $SLAVE_REG in $HOST_REG
#fem def xi;w;generic;example nodes contain of $SLAVE_REG in $HOST_REG

###################################################

# Fit the host mesh
fem def data;r;$TARGET;example
fem def xi;r;$LANDMARK;example reg $HOST_REG
#fem export data;$TARGET as $TARGET error full offset 100

fem def field;r;$HOST;example reg $HOST_REG
fem def elem;r;$HOST;example field reg $HOST_REG
fem def fit;r;$HOST;example geom reg $HOST_REG

fem fit reg $HOST_REG

###################################################

# Update the slave mesh
fem def xi;r;generic;example nodes of $SLAVE_REG in $HOST_REG
fem update mesh position fit of $SLAVE_REG in $HOST_REG 

#fem export node;$CUST_SLAVE as $CUST_SLAVE offset 1000 reg $SLAVE_REG
#fem export elem;$CUST_SLAVE as $CUST_SLAVE offset_elem 1000 reg $SLAVE_REG

###################################################

# Update the host mesh
fem update nodes fit reg $HOST_REG

#fem export nodes;$CUST_HOST as $CUST_HOST offset 2000 reg $HOST_REG
#fem export elements;$CUST_HOST as $CUST_HOST offset_elem 2000 reg $HOST_REG



