fem define parameter;r;arteries;example      # Declares array dimensions
fem reallocate;
fem define coordinate;r;arteries;example     # Defines the coordinate system
fem define node;r;arteries;example           # Reads in nodal information
fem define base;r;arteries;example           # Defines basis function (02 funcns : 1. 1D cubic hermite 2. 1D linear)
fem define element;r;arteries;example        # Reads in element information
fem define field;r;arteries;example          # Reads in fields. Only first field (unstressed radius at nodes) is necessary for this problem
fem define element;r;arteries;example field  # Defines interpolation of field variables (linear)
fem define grid;r;arteries;example coronary  # Defines grid points with coronary option to discretise the spatial computational domain. 
fem update grid geometry;
fem define equation;r;arteries;example       # Defines equations                          
fem define material;r;arteries;example       # Reads in physical & mechanical properties
fem update material field material 4 no_field 1;
#                                            # Updates unstressed radius (mat 4) from field 1
fem define time;r;aortic;example             # Define boundary conditions. Aortic press. at inlet and mean aortic press.(constant) at distal ends.
fem define initial;r;arteries;example        # Defines initial conditions
fem define solve;r;arteries;example          # Defines solution parameters

$time_initial=0.00;                          # Sets the initial time
$time_final=0.87;                            # Sets the final time
$time_step=0.0001;                           # Sets the time step time
$write_out_period=0.0435;                    # Sets the results write out period

fem export points;$time_initial grid as vessel offset 1000;         
fem export grid;vessel as vessel offset_node 1000 offset_elem 1000 elastic_tube; 

# Results output loop

for ($time=$time_initial;$time<$time_final;$time=$time+$write_out_period)       
{                                                                           
fem solve restart to $write_out_period delta_t $time_step;
fem export points;$time+$write_out_period grid as vessel offset 1000           
}                                                                           
