# example i24
# -----------

# This command file draws the magnetic fields and directions
# which are created by a virtual coil centred at the middle 
# of the SQUID

# Create purple colour
gfx cre mat purple diff 0.5 0.0 0.8 spec 0.4 0.5 0.0 shin 1.0 

# Read in the actual coil positions, the magnetic fields and gradients
gfx read data example coil_posn;
gfx read data example mfi_1_00001;
gfx read data example mfi_2_00001;
gfx read data example grad_00001;

# Create arrows at the coil and squid points which are oriented in the
# direction of the magnetic field
gfx mod g_elem mfi_1 data glyph arrow_solid size "3*3*3" orient magnetic_1 scale "2e9*0*0" mat purple;
gfx mod g_elem mfi_2 data glyph arrow_solid size "3*3*3" orient magnetic_2 scale "2e9*0*0" mat purple;
gfx mod g_elem mfi_grad data glyph arrow_solid size "3*3*3" orient grad scale "2e9*0*0" mat green;

# Draw in the position of the actual coils
gfx mod g_elem coils data glyph sphere size "3*3*3" mat gold;

# Move the second magnetic field out 50mm so that it is in a position 75mm
# from the surface of the torso (thus 75mm from the coils)
gfx set trans name mfi_2 1 0 0 0 0 1 0 0 0 0 1 0 0 -50 0 1;

# Position the magnetic field gradient at this distance also
gfx set trans name mfi_grad 1 0 0 0 0 1 0 0 0 0 1 0 0 -50 0 1;

# Open a 3D window and draw in axes
gfx cre win
gfx cre axes as axes length 100 mat black
gfx dr axes

# Modify the position of the data in the window
gfx mod win 1 back col 1 1 1

gfx mod win 1 layout height 774 width 764

gfx mod win 1 view parallel eye_point -723.498 -457.676 263.928 interest_point 18.0911 -314.074 12.0393 up_vector  0.175517 -0.983495 -0.0439513 view_angle 20.7613 near 7.96256 far 2845.55 ndc -1 1 2 2 viewport 0 0 1 1
