fem def para;r;fitting_lin
fem def coor;r;fit


#
# Sets up basis functions 
#   - 1 standard bicubic Hermite element
fem def base;r;bicubic_fit

#
# Reads in an initial mesh and calculates linear approximations
#  for the derivatives in xi=1 and 2 directions
#
#fem def node;r;epi
#fem def elem;r;epi
#fem refine xi 2 at 0.66
#fem refine xi 2 elements 1..11 at 0.5

fem def node;r;epi_refined
fem def elem;r;epi_refined

fem up node deriv 1 linear nodes 24..34
fem up node deriv 2 linear nodes 24..34


#
# The initial mesh
#
fem export node;epi_init as epi_init offset 0
fem export elem;epi_init as epi_init offset_elem 0


#
# Calculate the intial xi projections 
#   - alternatively the command fem def xi;c orthog can be used
#     it is slower but may produce better results in some cases
#
fem def data;r;epic
fem def xi;c close
fem li data err 
fem export data;epi_data as epi_data error


#
# Setup the fitting problem - 
fem up field from geometry

#
# Defines the fitting problem by setting smoothing parameters
#  and setting some fixed nodes.
#
fem def fit;r;epi geometry


#
# First fit
#
fem fit
fem update node fit
fem update scale_factor normalise
# The `old' option on `def xi;c' means that the last projections are used as
# initial estimates for the non-linear projection calculation.
fem def xi;c close old
fem li data err 

#
# Second fit
#
fem fit
fem update node fit
fem update scale_factor normalise
fem def xi;c close old
fem li data err 

#
# Third fit
#
fem fit
fem update node fit
fem update scale_factor normalise
fem def xi;c close old
fem li data err 


#
# Export the fitted geometry
#
fem export data;epi_data as epi_data error
fem export node;epi as epi offset 30000
fem export elem epi as epi offset_elem 30000




















fem define nodes;w;epi_fitted
fem define elem;w;epi_fitted

fem quit
