
#
# Sets up default colours and axes visualisation
#

gfx cre mat red      diff 1.0 0.0 0.0 spec 0.8 0.4 0.4 shin 1.0 alpha .9
gfx cre mat dblue    diff 0.0 0.1 1.0 spec 0.4 0.4 0.5 shin 0.5 
gfx cre mat gold     diff 1.0 0.7 0.0 spec 0.5 0.5 0.5 ambi 1.0 0.7 0.0 shin 0.8
gfx cre mat green    diff 0.0 1.0 0.0 alpha 0.9






#
# Initial Model
#
gfx read node epi_init
gfx read elem epi_init
gfx modify g_element epi_init general clear circle_discretization 6 default_coordinate default_coordinate element_discretization "8*8*8" native_discretization none
gfx modify g_element epi_init lines select_on material gold selected_material default_selected


#
# Model
#
gfx read node epi
gfx read elem epi
gfx modify g_element epi general clear circle_discretization 6 default_coordinate default_coordinate element_discretization "8*8*8" native_discretization none
gfx modify g_element epi lines select_on material green selected_material default_selected
gfx modify g_element epi node_points glyph point general size "1*1*1" centre 0,0,0 label cmiss_number select_on material default selected_material default_selected

#
# Data points 
#
gfx read data epi_data
gfx modify g_element epi_data general clear circle_discretization 6 default_coordinate default_coordinate element_discretization "4*4*4" native_discretization none
gfx modify g_element epi_data lines select_on material default selected_material default_selected
gfx modify g_element epi_data data_points glyph cross general size "1*1*1" centre 0,0,0 select_on material green selected_material default_selected
gfx modify g_element epi_data data_points glyph line general size "0*0*0" centre 0,0,0 orientation error scale_factors "1*1*1" select_on material dblue selected_material default_selected



#
# Hides axes visualisation and opens window 1
#

gfx set vis axes off
gfx create window 1 double_buffer
gfx modify window 1 image scene default light_model default
gfx modify window 1 image add_light default
gfx modify window 1 layout simple ortho_axes z -y eye_spacing 0.25 width 610 height 747
gfx modify window 1 set current_pane 1
gfx modify window 1 background colour 0 0 0 texture none
gfx modify window 1 view parallel eye_point -78.1417 -29.3258 60.208 interest_point -1.49711 2.66721 62.0534 up_vector 0.0264275 -0.00565306 -0.999635 view_angle 66.9472 near_clipping_plane 0.830745 far_clipping_plane 296.88 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1
gfx modify window 1 overlay scene none
gfx modify window 1 set transform_tool current_pane 1 std_view_angle 40 perturb_lines no_antialias slow_transparency
